' FtpFolderList.VBS V1.00 (C) yoshioka.teruo@nifty.com 2005-10-30
' FtpFolderList.VBS shows file list of FTP folder.
' Usage: Start FtpFolderList.VBS

Option Explicit
Dim fso
Dim wShell
Dim Shell
Dim ie

Set fso=CreateObject("Scripting.FileSystemObject")
Set wShell=CreateObject("WScript.Shell") 
Set Shell=CreateObject("Shell.Application") 

Set ie=Shell.Windows().Item()
If ie Is Nothing Then
  WScript.Echo "No Explorer Found."
  WScript.Quit
End If
If ie.ReadyState<>4 Then
  ie=Empty
ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual")=0 Then
  ie=Empty
End If
If IsEmpty(ie) Then
  For Each ie In Shell.Windows()
    If ie.ReadyState=4 Then _
    If InStr(TypeName(ie.Document),"IShellFolderViewDual")>0 Then Exit For
  Next
End If
If IsEmpty(ie) Then
  WScript.Echo "No Explorer Found."
  WScript.Quit
End If

Dim Folder
Dim FolderItem
Dim k
Dim COL:COL=3
Dim tPath
Dim StdOut
Dim Title
Dim Text
Dim j

Set Folder=ie.Document.Folder
On Error Resume Next
Title=Folder.Items().Item().Path
On Error GoTo 0
If Title="" Then
  Title=Folder.Title
ElseIf Left(Title,2)="::" Then
  Title=Folder.Title & " " & Title
End If

tPath=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetBaseName(fso.GetTempName()) & ".HTM")
Set StdOut=fso.CreateTextFile(tPath)

WriteLine "<html><head>"
WriteLine "<meta http-equiv=""Content-Type"" content=""text/html; charset=Shift_JIS"">"
WriteLine "<title>" & Title & "</title>"
WriteLine "</head><body>"
'WriteLine "<table>"
WriteLine "<table BORDER>"
WriteLine "<caption>" & Title & "</caption>"

WriteLine "<tr>"
For k=0 To COL
  WriteLine "<td>"&Array("O","TCY","","XV")(k)&"</td>"
Next
WriteLine "</tr>"

For j=0 To Folder.Items().Count-1
  Set FolderItem=Folder.Items().Item(j)
  WriteLine "<tr>"
  For k=0 To COL
    Select Case k
    Case 0 Text=FolderItem.Name
    Case 1 Text=FormatNumber(FolderItem.Size,0)
    Case 2 Text=FileType(fso.GetExtensionName(FolderItem.Name))
    Case 3 Text=FolderItem.ModifyDate
    End Select
    WriteLine "<td>"&text2html(Text)&"</td>"
  Next
  WriteLine "</tr>"
Next
WriteLine "</table></body></html>"

StdOut.Close

Set ie=CreateObject("InternetExplorer.Application")
ie.Visible=True
ie.Navigate tPath
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
Do While TypeName(ie)="IWebBrowser2"
  WScript.Sleep 100
Loop
fso.DeleteFile tPath

WScript.Quit

Sub WriteLine(Text)
Text=Replace(Text,ChrW(&HA0)," ") 	'&#160;&nbsp;sp
Text=Replace(Text,ChrW(&HA9),"(C)") 	'&#169;&copy;C
Text=Replace(Text,ChrW(&HAE),"(R)") 	'&#174;&reg;R
Text=Replace(Text,ChrW(&H2013),"-") 	'&#8211;&ndash;?
Text=Replace(Text,ChrW(&H2014),"|") 	'&#8212;&mdash;?
Text=Replace(Text,ChrW(&H02DC),"~") 	'&#732;&tilde;?
Text=Replace(Text,ChrW(&H2122),"TM") 	'&#8482;&trade;?

Dim char
Dim k
Dim code

On Error Resume Next
StdOut.WriteLine Text
If Err<>0 Then
  On Error GoTo 0
  For k=1 To Len(Text)
    char=Mid(line,k,1)
    On Error Resume Next
    StdOut.Write char
    If Err<>0 Then
      On Error GoTo 0
      code=AscW(char)
      If code<0 Then code=code+256*256
      char="&#"&code&";"
      StdOut.Write char
    Else
      On Error GoTo 0
    End If
  Next
  StdOut.WriteLine ""
Else
  On Error GoTo 0
End If
End Sub

Function text2html(Text) 
Text=Replace(Text,"&","&amp;") 
Text=Replace(Text,">","&gt;") 
Text=Replace(Text,"<","&lt;") 
Text=Replace(Text,"""","&quot;") 
text2html=Text 
End Function

Function FileType(ExtensionName)
FileType=RegRead("HKCR\."&ExtensionName&"\")
If FileType<>"" Then FileType=RegRead("HKCR\"&FileType&"\")
If FileType="" Then FileType=ExtensionName&" t@C"
End Function

Function RegRead(Key)
On Error Resume Next
RegRead=wShell.RegRead(Key)
End Function
